// axes.cxx
// from : http://www.sv.vt.edu/classes/opengl/lib/axes.c
/*
 * Copyright (c) 1994, 1996-1999  Silicon Graphics, Inc.  All rights reserved.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL SILICON GRAPHICS BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
 * POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/*  
 * axes.c
 */

#include <GL/glut.h>    /* includes gl.h, glu.h */

#include "axes.hxx"

void
XYaxes( void )
{
	glPushAttrib( GL_CURRENT_BIT | GL_ENABLE_BIT | GL_LINE_BIT );
	glLineWidth( 3.0f );
	glDisable( GL_LIGHTING );
	glBegin( GL_LINES );
		/* color X axis red */
		glColor3f( 1.0f, 0.0f, 0.0f );
		glVertex2f( 0.0f, 0.0f );
		glVertex2f( 1.5f, 0.0f );

		/* color Y axis green */
		glColor3f(  0.0f, 1.0f, 0.0f );
		glVertex2f( 0.0f, 0.0f );
		glVertex2f( 0.0f, 1.5f );
	glEnd();

	glBegin( GL_TRIANGLES );
		glColor3f( 1.0f, 0.0f, 0.0f );
		glVertex2f( 1.5f, 0.0f );
		glVertex2f( 1.35f, -0.05f );
		glVertex2f( 1.35f, 0.05f );
	
		glColor3f(  0.0f, 1.0f, 0.0f );
		glVertex2f( 0.0f, 1.5f );
		glVertex2f( -0.05f, 1.35f );
		glVertex2f( 0.05f, 1.35f );
	glEnd();
	glPopAttrib();
}

void
XYZaxes( void )
{
	glPushAttrib( GL_CURRENT_BIT | GL_ENABLE_BIT | GL_LINE_BIT );
	glLineWidth( 3.0f );
	glDisable( GL_LIGHTING );
	glBegin( GL_LINES );
		/* color X axis red */
		glColor3f(  1.0f, 0.0f, 0.0f );
		glVertex3f( 0.0f, 0.0f, 0.0f );
		glVertex3f( 1.5f, 0.0f, 0.0f );

		/* color Y axis green */
		glColor3f(  0.0f, 1.0f, 0.0f );
		glVertex3f( 0.0f, 0.0f, 0.0f );
		glVertex3f( 0.0f, 1.5f, 0.0f );

		/* color Z axis blue */
		glColor3f(  0.0f, 0.0f, 1.0f );
		glVertex3f( 0.0f, 0.0f, 0.0f );
		glVertex3f( 0.0f, 0.0f, 1.5f );
	glEnd();

	glBegin( GL_TRIANGLES );
		glColor3f(  1.0f, 0.0f, 0.0f );
		glVertex3f( 1.5f, 0.0f, 0.0f );
		glVertex3f( 1.35f, -0.05f, 0.0f );
		glVertex3f( 1.35f, 0.05f, 0.0f );
	
		glColor3f(  0.0f, 1.0f, 0.0f );
		glVertex3f( 0.0f, 1.5f, 0.0f );
		glVertex3f( -0.05f, 1.35f, 0.0f );
		glVertex3f( 0.05f, 1.35f, 0.0f );

		glColor3f(  0.0f, 0.0f, 1.0f );
		glVertex3f( 0.0f, 0.0f, 1.5f );
		glVertex3f( -0.05f, 0.0f, 1.35f );
		glVertex3f( 0.05f, 0.0f, 1.35f );
	glEnd();
	glPopAttrib();
}

// eof - axes.cxx
